import 'package:http/http.dart' as http;
import 'dart:io';
import 'dart:async';

class ConnectionUtils {
  static Future<bool> isResponseSuccessful(String url, {int timeout}) async
  {
    try{
      final response = await http.head(url);
      return response.statusCode >= 200 || response.statusCode < 300;
    }catch(e){
      print(e);
    }
    return false;
  }

  static Future<bool> isResponseOnline(String url, {int timeout}) async
  {
    final response = await http.head(url);

    switch(response.statusCode){
      case HttpStatus.notFound:
      case HttpStatus.requestTimeout:
      case HttpStatus.gatewayTimeout:
      case HttpStatus.networkConnectTimeoutError:
      return false;
    }
    return true;
  }
}