import 'package:flutter/material.dart';
import 'package:flutter/foundation.dart';

abstract class ILocalize<T>
{
  ILocalize.get();

  List<T> get values;

  T valueOf(String name) =>
    values?.firstWhere((value) => nameOf(value) == name, orElse: () => null);
  List<String> get valuesAsString {
    List<String> valuesAsString = [];
    values?.forEach((value) => valuesAsString.add(nameOf(value)));
    return valuesAsString;
  }

  String nameOf(T value) {
    try{return describeEnum(value);}catch(e){print(e);}
    return null;
  }
  List<String> get names {
    List<String> namesAsString = [];
    values?.forEach((value) => namesAsString.add(nameOf(value)));
    return namesAsString;
  }

  String locale(T value, {BuildContext context}) => "Locale not found";
  List<String> get locales {
    List<String> locales = [];
    values?.forEach((value) => locales.add(locale(value)));
    return locales;
  }

  String extended(T value) => "Extended not found";
}
